<p-table [scrollable]="true" [value]="timeReports" [style]="{width:'100%'}" [autoLayout]="true" tableStyleClass="table-with-action-buttons">
    <ng-template pTemplate="header">
      <tr>
        <th>Date</th>
        <th>Account</th>
        <th>Project</th>
        <th class="nowrap">Int. / Ext.</th>
        <th class="w-25">Description</th>
        <th>Overhead</th>
        <th style="width: 74px">
          <!-- Enable this button once user defaults preload is implemented -->
          <button *ngIf="false" pButton icon="fa fa-plus"
            (click)="showAddReportDialog()"
          ></button>
        </th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-report>
      <tr>
        <td class="w-10">{{report.reportingDate | date:'shortDate'}}</td>
        <td class="w-15">{{report.account.name}}</td>
        <td class="w-25">{{report.project.name}}</td>
        <td class="w-10">{{report.internalHours}} / {{report.externalHours}}</td>
        <td class="w-25 description">{{report.workDescription}}</td>
        <td class="w-10">{{report.isOverhead ? 'Yes' : 'No'}}</td>
        <td style="width: 74px">
          <div class="d-flex justify-content-between">
            <ng-template #editControls [ngTemplateOutlet]="editControls"
                  let-isTimeReportNotEditable="isTimeReportNotEditable"
                  [ngTemplateOutletContext]="{ isTimeReportNotEditable: !report.isEditable}"
            >
              <button pButton icon="fa fa-pencil" [disabled]="isTimeReportNotEditable" (click)="showEditReportDialog(report)"></button>
              <button pButton icon="fa fa-times" [disabled]="isTimeReportNotEditable" (click)="onDeleteTimeReport(report)" class="p-button-danger"></button>
            </ng-template>
          </div>
        </td>
      </tr>
    </ng-template>
</p-table>

<p-dialog #editDialog *ngIf="isEditDialogVisible"
    [(visible)]="isEditDialogVisible"
    [responsive]="true"
    [resizable]="false"
    [focusOnShow]="false"
    showEffect="fade"
    appendTo="body"
    [modal]="true"
    [style]="{ 'width': '900px' }"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }">
    <app-time-report
        [projects]="projects"
        [(selectedProject)]="selectedTimeReport.project"
        [(date)]="reportingDate"
        [(internalHours)]="selectedTimeReport.internalHours"
        [(externalHours)]="selectedTimeReport.externalHours"
        [(isOverhead)]="selectedTimeReport.isOverhead"
        [(description)]="selectedTimeReport.workDescription"
        [(startTime)]="startTime"
        submitButtonLabel="Save"
        [allowMultipleDates]="false"
        (submitButtonClick)="onEditTimeReport()"
    ></app-time-report>
</p-dialog>

<p-dialog #addDialog *ngIf="isAddDialogVisible"
    [(visible)]="isAddDialogVisible"
    appendTo="body"
    [responsive]="true"
    [resizable]="false"
    [focusOnShow]="false"
    showEffect="fade"
    [modal]="true"
    [style]="{ 'width': '900px'}"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }">
    <app-time-report
        [projects]="projects"
        [(selectedProject)]="selectedTimeReport.project"
        [(date)]="reportingDate"
        [(internalHours)]="selectedTimeReport.internalHours"
        [(externalHours)]="selectedTimeReport.externalHours"
        [(isOverhead)]="selectedTimeReport.isOverhead"
        [(description)]="selectedTimeReport.workDescription"
        [(startTime)]="startTime"
        submitButtonLabel="Add Report"
        [allowMultipleDates]="false"
        (submitButtonClick)="onAddTimeReport()"
        [appendInnerDialogToBody]="true"
    ></app-time-report>
</p-dialog>
